﻿using System;
using System.Web;
using System.IO;
using System.Security;
using System.Security.Cryptography;
using System.Security.Cryptography.Xml;
using System.Xml;
using System.Reflection;
using AlpineSoft;

namespace SignXml {
    public partial class SignXml : System.Web.UI.Page {
        protected void Page_Load(object sender, EventArgs e) {
            

            string xml = "";

            if (Page.Request["createKey"] != null)
                xml = Page.Request["createKey"];
            else {
                xml = "<?phpxml version=\"1.0\" encoding=\"utf-8\"?><mydata><xs:schema id=\"license\" elementFormDefault=\"qualified\" xmlns:xs=\"http://www.w3.org/2001/XMLSchema\" xmlns:dsig=\"http://www.w3.org/2000/09/xmldsig#\" version=\"1.0\"><xs:import id=\"schema\" namespace=\"http://www.w3.org/2000/09/xmldsig#\" /><xs:element name=\"license\"><xs:complexType><xs:sequence><xs:element name=\"licenseType\" type=\"xs:string\" minOccurs=\"1\" maxOccurs=\"1\" nillable=\"false\" /><xs:element name=\"expireDate\" type=\"xs:string\" minOccurs=\"1\" maxOccurs=\"1\" nillable=\"false\" /><xs:element name=\"activateDate\" type=\"xs:string\" minOccurs=\"1\" maxOccurs=\"1\" nillable=\"false\" /><xs:element name=\"lastRequest\" type=\"xs:string\" minOccurs=\"1\" maxOccurs=\"1\" nillable=\"false\" /><xs:element name=\"promoCode\" type=\"xs:string\" minOccurs=\"1\" maxOccurs=\"1\" nillable=\"false\" /><xs:element name=\"compId\" type=\"xs:string\" minOccurs=\"1\" maxOccurs=\"1\" nillable=\"false\" /><xs:element name=\"compAddress\" type=\"xs:string\" minOccurs=\"1\" maxOccurs=\"1\" nillable=\"false\" /><xs:element name=\"numRequests\" type=\"xs:string\" minOccurs=\"1\" maxOccurs=\"1\" nillable=\"false\" /><xs:element name=\"trialLength\" type=\"xs:string\" minOccurs=\"1\" maxOccurs=\"1\" nillable=\"false\" /><xs:element name=\"email\" type=\"xs:string\" minOccurs=\"1\" maxOccurs=\"1\" nillable=\"false\" /><xs:element name=\"unlockCode\" type=\"xs:string\" minOccurs=\"1\" maxOccurs=\"1\" nillable=\"false\" /><xs:element name=\"custId\" type=\"xs:string\" minOccurs=\"1\" maxOccurs=\"1\" nillable=\"false\" /><xs:element name=\"version\" type=\"xs:string\" minOccurs=\"1\" maxOccurs=\"1\" nillable=\"false\" /><xs:element name=\"parts\" type=\"xs:string\" minOccurs=\"1\" maxOccurs=\"1\" nillable=\"false\" /><xs:element ref=\"dsig:Signature\" minOccurs=\"0\" maxOccurs=\"1\" /></xs:sequence></xs:complexType></xs:element></xs:schema><license><licenseType>FAHoldem</licenseType><expireDate>notset</expireDate><activateDate>notset</activateDate><lastRequest>notset</lastRequest><promoCode>notset</promoCode><compId>AFE9FBFF000006D8</compId><compAddress>192.168.254.6</compAddress><numRequests></numRequests><trialLength></trialLength><email>email</email><unlockCode>trial</unlockCode><custId>AFE9FBFF000006D8</custId><version></version><parts></parts></license></mydata>";
            }

            // Load the license request file
            XmlDocument xmldoc = new XmlDocument();
            //  xmldoc.LoadXml(Page.Request["createKey"]);


            xmldoc.LoadXml(xml);

            //embedd xml method
           // RSACryptoServiceProvider csp2 = new RSACryptoServiceProvider(1024);

            EZRSA csp2 = new EZRSA(1024);
            string rstatus = "";
            string signKey = SignXml.LoadKey("SignXml.SignKey.xml", ref rstatus, this);

            if (rstatus != "") {
                Response.Write("LoadKey=" + rstatus);
                return;
            }

            // Response.Write("identity: " + System.Security.Principal.WindowsIdentity.GetCurrent().Name);
            // return;

            //Response.Write("<br>signed: ");

            csp2.FromXmlString(signKey);
            //end embedd xml method

            //SignData();
            if (csp2 != null) {

                Sign(csp2, xmldoc);

                XmlTextWriter writer = new XmlTextWriter(Response.Output);
                writer.Formatting = Formatting.Indented;

                try {
                    xmldoc.WriteTo(writer);
                }
                finally {
                    writer.Flush();
                    writer.Close();
                }
            }
        }


        public static string LoadKey(string resourceName, ref string status, object assemType) {
            //string status = "";
            // Get the XML content from the embedded XML public key.
            Stream s = null;
            string xmlkey = string.Empty;
            try {
                //Assembly assem = assemType.GetType().Assembly;
                Assembly assem = Assembly.GetExecutingAssembly();
                s = assem.GetManifestResourceStream(resourceName);
                //s = typeof(Updater).Assembly.GetManifestResourceStream(resourceName);

                // Read-in the XML content.
                StreamReader reader = new StreamReader(s);
                xmlkey = reader.ReadToEnd();
                reader.Close();
            }
            catch (Exception e) {
                status = "Error: could not import public key: " + e.Message;
                return "";
            }

            return xmlkey;

        }

        ///         
        /// Add a digital signature to the specified xml document.        
        ///         
        public static void Sign(RSA rsa, XmlDocument doc) {            
            //string result = null;            
            // Creating the XML signing object.            
            SignedXml sxml = new SignedXml(doc);            
            sxml.SigningKey = rsa;            // Set the canonicalization method for the document.            
            sxml.SignedInfo.CanonicalizationMethod =                
                SignedXml.XmlDsigCanonicalizationUrl; // No comments.            
            // Create an empty reference (not enveloped) for the XPath            
            // transformation.            
            Reference r = new Reference("");            
            // Create the XPath transform and add it to the reference list.            
            r.AddTransform(new XmlDsigEnvelopedSignatureTransform(false));            
            // Add the reference to the SignedXml object.            
            sxml.AddReference(r);            // Compute the signature.            
            sxml.ComputeSignature();            
            // Get the signature XML and add it to the document element.            
            XmlElement sig = sxml.GetXml();            
            doc.DocumentElement.AppendChild(sig);        
        }


    }
}
