﻿using System;
using System.Web;
using System.IO;
using System.Text;
using System.Security;
using System.Security.Cryptography;
using System.Security.Cryptography.Xml;
using System.Xml;
using System.Reflection;
using AlpineSoft;

namespace UniqueHash {

    public partial class UniqueHash : System.Web.UI.Page {

        protected void Page_Load(object sender, EventArgs e) {

            string unlock = "";
            string custId = "";

            if (Page.Request["unlock"] != null) {
                unlock = Page.Request["unlock"];
                custId = Page.Request["custId"];
            }
            else {//test data
                unlock = "E25VM247K3YL7487";
                custId = "35CJ7M1.35CJ7M1.";
            }

            //embedd xml method
            // RSACryptoServiceProvider csp2 = new RSACryptoServiceProvider(1024);

            EZRSA csp2 = new EZRSA(1024);
            string rstatus = "";
            string hashKey = UniqueHash.LoadKey("SignXml.HashKey.xml", ref rstatus, this);

            if (rstatus != "") {
                Response.Write("hashKey=" + rstatus);
                return;
            }

            XmlDocument xmldoc = new XmlDocument();

            csp2.FromXmlString(hashKey);
            xmldoc.LoadXml(csp2.ToXmlString(false));
            string password = xmldoc.InnerText;


            // generate hash
            HMACSHA1 hmac = new HMACSHA1();

            hmac.Key = Encoding.ASCII.GetBytes(password);

            //hmac.C
            hmac.ComputeHash(Encoding.ASCII.GetBytes(unlock + custId));

            // convert hash to hex string
            StringBuilder sb = new StringBuilder();
            for (int i = 0; i < hmac.Hash.Length; i++) {
                sb.Append(hmac.Hash[i].ToString("X2"));
            }

            // the the final hash as a string
            Response.Write(sb.ToString());
        }


        public static string LoadKey(string resourceName, ref string status, object assemType) {
            //string status = "";
            // Get the XML content from the embedded XML public key.
            Stream s = null;
            string xmlkey = string.Empty;
            try {
                //Assembly assem = assemType.GetType().Assembly;
                Assembly assem = Assembly.GetExecutingAssembly();
                s = assem.GetManifestResourceStream(resourceName);
                //s = typeof(Updater).Assembly.GetManifestResourceStream(resourceName);

                // Read-in the XML content.
                StreamReader reader = new StreamReader(s);
                xmlkey = reader.ReadToEnd();
                reader.Close();
            }
            catch (Exception e) {
                status = "Error: could not import public key: " + e.Message;
                return "";
            }

            return xmlkey;

        }


    }
}
